%define oldversion 20.7
Name: emacs
Version: 21.2
Release: alt14

Group: Editors
Summary: GNU Emacs text editor
License: GPL

URL: http://www.gnu.org/software/emacs/

Source0: rsync://ftp.gnu.org/gnu/%name/%name-%version.tar.bz2
Source1: rsync://ftp.gnu.org/gnu/%name/leim-%version.tar.bz2
Source2: TUTORIAL.ru

Source7: README.KOI8-U

Source110: http://prdownloads.sourceforge.net/php-mode/php-mode-102.el
Source111: emacs-mode-php.site-start.el

Source12: gnu-mini.xpm
Source13: gnu-normal.xpm
Source14: gnu-large.xpm

# from Serhij Hlodin
Source16: CHANGES.ukr
Source17: INSTALL.ukr
Source18: README.UK

Source22: %name.menu
Source23: %name-lisp-pkgutils-0.1.1.tar

# Mdk's and ALT's global configs merged: the X resources
Source31: %name-21.2-alt14-xresources-ALT

# List of some large .elc files to be compressed:
Source40: %name-21.2-el-to-compress.ls

################### Patches  ##########################
# ALT's libtinfo; POSIX locks via fcntl convention:
Patch0: %name-21.2-alt-system.patch

# Try to load also bzipped2 .el/.elc files 
# as well as with gzipped and uncompressed variants (supported before)
Patch1: %name-21.2-alt14-load-el_bz2.patch
# isn't applied (21.2-alt1): indicator is already disabled in the GNU release:
Patch2: %name-21.1-enc-kb-short-indicator.patch
Patch3: %name-21.2-alt11-clipboard.patch

# We don't want the whole pkg depend on rcs 
# just because someone may want to use it:
Patch4: %name-21.2-hide-rcs-deps.patch
Patch5: %name-21.2-Meta-Alt-Ctrl-Hyper-super-discard-state.patch
# the freshest pc-select.el (from the HEAD of CVS)
Patch6: %name-21.2-HEAD-pc-select.diff
Patch7: %name-21.2-pc-select-private-mark.patch
Patch8: %name-21.2-ediff-diff-options-check-c.patch
Patch9: %name-21.2-regex-encoded.patch
Patch10: %name-21.2-face-font-selection-slant-important.patch

# These two patches make the real work for ukrainisation:
Patch20: %name-21.1-uk.patch
Patch21: leim-21.1-uk.patch
Patch22: leim-20.6-belarusian.patch

# !! This patch is not applied -- do we need it at all?
Patch30: %name-20.7-terminfofix.patch

# Why a broken version of this patch is applied in GNU 21.2????!!
Patch31: %name-21.2-dumbterm-for-compile.patch

Patch32: %name-21.1-cp866fix.patch
Patch33: %name-21.2-alt14-more-cyrillic-support.patch
#Patch33: %name-21.2-alt10-cyrillic-cp-lang-envs.patch
Patch34: %name-21.1-lang-env-prereqs.patch

Patch35: %name-21.2-alt12-tutorial-ru.patch

# End of Patches #
##################

# We use awk for output parsing and error-msg detection:
BuildRequires(build): awk
# We use zme:
BuildRequires(install): bzip2-utils
# <term.h> is there since then:
BuildRequires(build): libtinfo >= 5.2.20020622-alt2

BuildRequires(build): autoconf_2.13
%set_autoconf_version 2.13
# The default value in rpm-4.0.4-alt11 seems to make it wrong:
# it sets the --build parameter :-(
%define _configure_target --host=%_target_platform

# Automatically added by buildreq on Sat Jul 20 2002
BuildRequires: XFree86-devel XFree86-devel-static XFree86-libs XFree86-locales inews ispell-en libXaw3d-devel libjpeg-devel libpng-devel libtiff-devel libtinfo-devel libungif-devel postfix words xpm-devel zlib-devel

%description
Emacs is an extensible, customizable, self-documenting real-time
display editor.  Emacs contains special code editing features, an
extension language (Emacs Lisp), and the capability to read mail, news
and more without leaving the editor.

This package includes things you need to run the Emacs editor, so you
need to install this package if you intend to use Emacs.  You also
need to install the actual Emacs program package (%name-nox or
%name-X11).  Install %name-nox if you are not going to use the X
Window System; install %name-X11 if you will be using X.

%package common
Summary: Things needed to run the GNU Emacs text editor
Group: Editors
Obsoletes: %name
# Common is useless without an Emacs binary:
Requires: %name = %version-%release
# We do not include speedbar from GNU's distro;
# so we require th external one.
Requires: %name-speedbar

Conflicts: etcskel < 2.0.2-alt1

%description common
Emacs is an extensible, customizable, self-documenting real-time
display editor.  Emacs contains special code editing features, an
extension language (Emacs Lisp), and the capability to read mail, news
and more without leaving the editor.

This package includes things you need to run the Emacs editor, so you
need to install this package if you intend to use Emacs.  You also
need to install the actual Emacs program package (%name-nox or
%name-X11).  Install %name-nox if you are not going to use the X
Window System; install %name-X11 if you will be using X.

%package el
Summary: The sources for Lisp programs included with Emacs
Group: Development/Other
Requires: %name-common = %version-%release

%description el
Emacs-el contains the Emacs Lisp sources for many of the programs
included with the main Emacs text editor package.

You need to install %name-el only if you intend to modify any of the
Emacs packages or see some Lisp examples.

If you need the sources for %name-leim, install %name-leim-el.

%package leim
Summary: Emacs Lisp code for input methods for internationalization
Group: Editors
Requires: %name-common = %version-%release

%description leim
The Emacs Lisp code for input methods for various international scripts.

%package leim-el
Summary: The Emacs Lisp source code for input methods included in %name-leim
Group: Development/Other
Requires: %name-leim = %version-%release

%description leim-el
Emacs-leim-el contains the Emacs Lisp sources for the Emacs Lisp code
for input methods for various international scripts.

You need to install %name-leim-el only if you intend to modify any of theses
Emacs packages, see some Lisp examples or for reference for configuring your
localized input methods.

#
%package gnus
Summary: Read news and mail from within Emacs
Group: Networking/Mail
Provides: gnus = %name:%version-%release
Conflicts: gnus < %name:%version-%release, gnus > %name:%version-%release
Requires: %name-common = %version-%release

%description gnus
Gnus is a GNU Emacs based MUA.

The news can be gotten by any nefarious means you can think of--NNTP, local
spool or your mbox file.  All at the same time, if you want to push your
luck.

This is the version of Gnus included in GNU Emacs distribution.

Only byte-compled elisp files are included. Install %name-gnus-el package
if you need the sources.

%package gnus-el
Summary: Elisp source code for %name-gnus
Group: Development/Other
Requires: %name-gnus = %version-%release

%description gnus-el
This package contains the elisp source code for the elc-files from %name-gnus
package (the GNU Emacs based MUA).

You may need them to debug, explore them, or modify.

#
%package nox
Summary: The Emacs text editor without support for the X Window System
Group: Editors
Requires: %name-common = %version-%release
Provides: %name = %version-%release
Requires: emacsen-startscripts
Provides: emacsen

%description nox
Emacs-nox is the Emacs text editor program without support for
the X Window System.

You need to install this package only if you plan on exclusively using
Emacs without the X Window System (%name-X11 will work both in X and out
of X, but %name-nox will only work outside of X).  You will also need to
install the %name-common package in order to run Emacs.

#
%package X11
Summary: The Emacs text editor for the X Window System
Group: Editors
Requires: %name-common = %version-%release
Provides: %name = %version-%release
Requires: emacsen-startscripts
Provides: emacsen
Conflicts: app-defaults < 0.2.1-alt1

%description X11
Emacs-X11 includes the Emacs text editor program for use with the X
Window System (it provides support for the mouse and other GUI
elements).  Emacs-X11 will also run Emacs outside of X, but it has a
larger memory footprint than the 'non-X' Emacs package (%name-nox).

Install %name-X11 if you are going to use Emacs with the X Window
System.  You should also install %name-X11 if you are going to run
Emacs both with and without X (it will work fine both ways).  You will
also need to install the %name-common package in order to run Emacs.

%prep
%setup -q -b1

%patch0 -p1
%patch1 -p1
# The indicator turned off in GNU's 21.2 release, the patch no needed so far. 
#%patch2 -p1
%patch3 -p1

%patch4 -p1
%patch5 -p1 -b .ctrl
%patch6 -p2
%patch7 -p1
%patch8 -p1
%patch9 -p1 -b .regex-encoded
%patch10 -p1

# tutorial in Russian:
cp %SOURCE2 etc

cp %SOURCE110 lisp/progmodes/php-mode.el

# Ukrainian docs:
cp %SOURCE16 .
cp %SOURCE17 .
cp %SOURCE18 .
cp %SOURCE7 .

%patch20 -p1
%patch21 -p1
%patch22 -p0

#%patch30 -p1
%patch31 -p1

# add support for prereq-features of language-environment-info
%patch34 -p1
# fix cp866 table:
%patch32 -p1
# add CP*-based lang-envs and font support:
%patch33 -p1

%patch35 -p1

perl -pi -e 's|(\.\./info/[[:alpha:]-]+)|$1.info|g' man/*
rm -f info/*

%build
# Try to detect errors and break on errors:
%define detect_elisp_errs 2>&1 | awk '/!! /{ r++; } END{ if (r) printf "There were %%d errors while recompiling Emacs Lisp modules.\n", r; exit r; } /.*/'

%define _configure_script ../configure

function Substage() {
 echo "Substage #$1. $2:"
}

# We build two binaries (with X and without X support) 
# in several symmetric substages.
Substage 0 "Clear and create the both build directories"
[ -d build-nox ] && rm -rf build-nox; mkdir build-nox
[ -d build-withx ] && rm -rf build-withx; mkdir build-withx

Substage 1 "Configure"
pushd build-nox
%configure --sharedstatedir=/var --with-gcc --with-pop --with-x=no
popd
pushd build-withx
%configure --sharedstatedir=/var --with-gcc --with-pop --with-x-toolkit --with-png --with-jpeg --with-xpm --with-gif --with-tiff
popd

Substage 2 "Initial make all" 
#no SMP
pushd build-nox; make; popd
pushd build-withx; make; popd

Substage 3 "Make supplementary (and important) things only once (asymmetricly) 
 (for possibly more capabilities -- in the X build)"
pushd build-withx
make -C man
{
    # Recompile so that the patches we have applied are effective:
    make -C lisp recompile
    # Compile php-mode:
    make -C lisp progmodes/php-mode.elc
    # Compile the small new file:
    make -C lisp international/cyrillic-codepages-setup.elc
} %detect_elisp_errs
popd # build-withx

Substage 4 "Final make all (now that we have all patched Lisp code compiled, 
 also a bit asymmetric), clean previous binaries"
#no SMP
pushd build-withx
  %__rm -f src/emacs src/emacs-*
  make
popd
pushd build-nox
  # Override some data with more complete from the X build
  # (exactly the X variant of the data will be included in the package,
  # so emacs-nox has to work correctly in this environment):
  %__rm -rf etc leim; %__ln_s -f ../build-withx/{etc,leim} .
  %__rm -f src/emacs src/emacs-*
  make
popd

tar xvf %SOURCE23 # el-pkgutils


%install
mkdir -p $RPM_BUILD_ROOT%prefix
%makeinstall -C build-withx
install -p -m755 build-nox/src/%name $RPM_BUILD_ROOT%_bindir/%name-nox
mv $RPM_BUILD_ROOT%_bindir/%name-{%version,X11}

# Packager's tools - to be used in this and other pkgs
pushd el-pkgutils
 %__install -m0755 el-pkgutils.sh "$RPM_BUILD_ROOT%_libdir/%name/"
 %__install -m0644 el-pkgutils.el "$RPM_BUILD_ROOT%_emacslispdir/"
popd


# All the install's below have nothing to do with the Source directory
# So we want to make the command arguments shorter 
# by replacing "$RPM_BUILD_ROOT" with "."
pushd "$RPM_BUILD_ROOT" # there will be a popd below

# leim's Makefile doesn't ignore .orig; remnove them:
find .%_datadir/%name/%version/leim -type f -name '*.orig' -print0 \
	| xargs -0 rm -f

# Compress some files: 
{ 
    cat %SOURCE40 | sed -e 's:^:.%_datadir/%name/%version/:'
    for o in .%_datadir/%name/%version/lisp/obsolete/*.elc; do echo "$o"; done  
} | xargs gzip -9 -v 2>&1 | sed -e 's@:.*$@.gz@' | xargs zme

# Site start configuration:
# Link to a file provided by emacsen-startscripts pkg:
(cd .%_datadir/emacs/%version/lisp; ln -s ../../../../..%_sysconfdir/emacs/site-start.el)

# PHP mode site-start script:
%__install -pD -m0644 %SOURCE111 .%_sysconfdir/emacs/site-start.d/php.el

#######################
# Various other stuff #
#######################

mkdir -p .%_libdir/%name/site-lisp

%__mv .%_mandir/man1/{,g}ctags.1
%__mv .%_bindir/{,g}ctags

# Exclude speedbar:
%__rm -f .{%_datadir/%name/%version/lisp,%_infodir}/speedbar*

# Separate Gnus:
%__mv .%_datadir/%name/%version/lisp/gnus/format-spec* .%_datadir/%name/%version/lisp/
%__mv .%_datadir/%name/%version/lisp/gnus .%_datadir/%name/site-lisp/

rm -f .%_infodir/info*

################
# Menu support #
################
mkdir -p .%_menudir
cat "%SOURCE22" | sed -e 's:%%version:X11:' > .%_menudir/%name-X11
install -p -m644 -D %SOURCE12 .%_miconsdir/%name.xpm
install -p -m644 -D %SOURCE13 .%_iconsdir/%name.xpm
install -p -m644 -D %SOURCE14 .%_liconsdir/%name.xpm

###############
# X resources #
###############
xrdir=%_sysconfdir/X11/app-defaults
%__mkdir_p ."$xrdir"
%__install -p -m0644 %SOURCE31 ."$xrdir/Emacs"
unset xrdir


popd # "$RPM_BUILD_ROOT"

#####################
# Create file lists #
#####################
# INFO
%define common_infos ada-mode,autotype,ccmode,cl,dired-x,ebrowse,ediff,efaq,%name,eshell,eudc,forms,idlwave,mh-e,pcl-cvs,reftex,sc,vip,viper,widget,woman
%define gnus_infos emacs-mime,gnus,message
%define gnus_infos_pattern gnus\\|emacs-mime\\|message

# source previously installed tools (bash functions that call el-functions)
. "$RPM_BUILD_ROOT"%_libdir/%name/el-pkgutils.sh
EMACS_BIN="emacs-nox"
EL_PKGUTILS_ROOT="$RPM_BUILD_ROOT"
# Clear the lists:
%__rm -f {main,leim,gnus}{,-el}.ls info.ls

# Generate them:
# INFO
common_infos=( $(ls "$RPM_BUILD_ROOT"%_infodir/*.info* \
| sed -e "s:^$RPM_BUILD_ROOT%_infodir/::" \
| sed -e 's:\.info.*$::' | sort -u \
| egrep -v %gnus_infos_pattern ) )
gnus_infos=( $(ls "$RPM_BUILD_ROOT"%_infodir/*.info* \
| sed -e "s:^$RPM_BUILD_ROOT%_infodir/::" \
| sed -e 's:\.info.*$::' | sort -u \
| egrep %gnus_infos_pattern ) )

( # save IFS
IFS=,
if [[ '%common_infos' != "${common_infos[*]}" ]]; then
	echo "common_infos lists do not match, correct them!"
	exit 1
fi
if [[ '%gnus_infos' != "${gnus_infos[*]}" ]]; then
	echo "gnus_infos lists do not match, correct them!"
	exit 1
fi
) || false

fraction \
 '(dirs "%_libdir/%name/%version" "%dir") "main.ls"' \
 '(files "%_libdir/%name/%version" 
    (lambda(f) (if (string-match "/movemail$" f) "%attr(-,root,mail)")) )
  "main.ls"' \
 \
 '(dirs "%_datadir/%name/%version/etc" "%dir") "main.ls"' \
 '(files "%_datadir/%name/%version/etc" 
    (lambda(f) (if (string-match "gnus" f) "#")) )
  "main.ls"' \
 '(files "%_datadir/%name/%version/etc" 
    (lambda(f) (if (not (string-match "gnus" f)) "#")) )
  "gnus.ls"'

standard_fraction_el_elc main "%_datadir/%name/%version/lisp"
standard_fraction_el_elc leim "%_datadir/%name/%version/leim"
standard_fraction_el_elc gnus "%_datadir/%name/site-lisp/gnus"

# INFO
printf '%s\n' %_infodir/{%common_infos}'.info*' >> main.ls
printf '%s\n' %_infodir/{%gnus_infos}'.info*' >> gnus.ls


%define restore_generic_emacs if [ ! -f %_bindir/emacs ]; then update-alternatives --auto emacs; fi
%define alternativeMajor %(echo %version | tr -d .)

# common
%post common
%install_info {%common_infos}.info

%preun common
%uninstall_info {%common_infos}.info

# gnus
%post gnus
%install_info {%gnus_infos}.info

%preun gnus
%uninstall_info {%gnus_infos}.info

# nox
%post nox
update-alternatives --install %_bindir/emacs emacs %_bindir/emacs-nox 10
%restore_generic_emacs

%preun nox
if [ "$1" = 0 ]; then 
    update-alternatives --remove emacs %_bindir/emacs-nox
fi

# X11
%post X11
update-alternatives --install %_bindir/emacs emacs %_bindir/emacs-X11 20
%restore_generic_emacs
%update_menus

%preun X11
if [ "$1" = 0 ]; then
    update-alternatives --remove emacs %_bindir/emacs-X11
fi

%postun X11
%clean_menus
if [ "$1" = 0 ]; then
    update-alternatives --remove emacs %_bindir/emacs-%oldversion
fi

#
%files common -f main.ls
%doc etc/NEWS BUGS README README.KOI8-U README.UK CHANGES.ukr INSTALL.ukr

%config(noreplace) %_sysconfdir/emacs/site-start.d/php.el

%_bindir/b2m
%_bindir/%{name}client
%_bindir/etags
%_bindir/gctags
%_bindir/rcs-checkin
%_mandir/man?/*

%dir %_libdir/%name
%dir %_libdir/%name/site-lisp

%dir %_emacslispdir
%_emacslispdir/*.el*
%dir %_datadir/%name/%version
%dir %_datadir/%name/%version/site-lisp
%dir %_datadir/%name/%version/leim

# Some .el-files that have .elc-companions,
# but are still preferrable to have in the main
# package (for reference) may be listed here:
#%_datadir/%name/%version/lisp/bindings.el -- probably there is no need for this
#%_datadir/%name/%version/lisp/mail/sc.el
#%_datadir/%name/%version/lisp/term-nasty.el

# This should be a symlink
%_datadir/emacs/%version/lisp/site-start.el

# packager's tools (to be used in other pkgs with Emacs Lisp)
# - a shel interface to Lisp module installed in %_emacslispdir
%_libdir/%name/el-pkgutils.sh

%files el -f main-el.ls

#
%files leim -f leim.ls

%files leim-el -f leim-el.ls

#
%files gnus -f gnus.ls

%files gnus-el -f gnus-el.ls

#
%files nox
%_bindir/%name-nox

#
%files X11
#%_bindir/%name-%version
%_bindir/%name-X11

%config(noreplace) %_sysconfdir/X11/app-defaults/*

%_menudir/%name-X11

%_iconsdir/%name.xpm
%_miconsdir/%name.xpm
%_liconsdir/%name.xpm

%changelog
* Mon Feb 10 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt14
- changes to better support various Cyrillic X fonts 
  (news in patch33):
  + faces.el: face-font-registry-alternatives: list the wide-spread 
    alternatives for Cyrillic iso8859-5 (microsoft-cp1251, koi8-u, koi8);
  + fontset.el: leave "ISO8859-5" as the REGISTRY-ENCODING for Cyrillic;
  + fontset.el: change the FAMILY for Cyrillic from "*" (any) to nil 
    (the same a sthe default), because Cyrillic is like Latin: the family
    plays just hte same role;
  + describe koi8-c X font encoding (gor now, just as an alias for koi8-u);
  (patch10):
  + make :slant the most important property when selecting a font for a face
    (imho, the absence of slanted fonts makes the visual appearance dull);
  (source31):
  + remove all font-related settings from /etc/X11/app-defaults/Emacs (which
    used to be brute), add only "Emacs.default.attributeFamily: fixed";
  + now, there is no need to specify rather brute values in localized
    /etc/X11/Xresources.* in order to get the right encoded Cyrillic font --
    we get it without any special X resources, if the Cyrillic font is 
    available (modify app-defaults accordingly!);
    (a part of the fix for No. 0000825, 0001478, 0001681; complete 0000997);
- open bzipped2 .el files (as well as gzipped which was supported before)
  when following links from the Help buffer (e.g., C-h v) (patch1;
  fixes No. 0001927 at http://bugs.altlinux.ru).

* Mon Feb 10 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt13
- fix regex processing for some specially encoded texts (patch9, useful
  for Gnus, sent by Alex Ott <ottalex@narod.ru>);
- add BuildRequires(install): bzip2-utils (to fix No. 0001911).

* Sun Dec  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt12
- files: 
  + include non-el/elc files from lisp/ (mainly xpm; fixes No. 0001387);
  + exclude gnus/ from emacs-common (it was included in a previous revision);
  + compress .el-files in *-el pkgs;
- corrected TUTORIAL.ru (Alex Ott <ottalex@narod.ru>);
- spec-file: thoroughly check that all info-files are included
  (fixes No. 0001386);

* Sun Nov 17 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt11
- make possible primary X selection setting & pasting with mouse
  (in addition to clipboard manipulation with keys; fixes No. 1356);
- pc-selection-mode: turn-offable; no conflict with traditional 
  selection manipulation keys (like C-space; fixes No. 1357 at 
  bugs.altlinux.ru);
- lisp/ediff-diff.el: refine the check for valid ediff-diff-options;

* Sat Nov  9 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt10
- make finer distinction between koi8-r & koi8-u font encodings
  (fixes No. 997 at bugs.altlinux.ru).

* Fri Nov  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt9
- make keys like C-h, M-x work even when the (say) Russian XKB 
  group is active (patch5, discard almost the whole state if
  a certain modifier is detected; fixes No. 852 at bugs.altlinux.ru).
  (Please REPORT any related misbehaviors!)

* Thu Nov  7 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt8
- use --host=%%_target_platform for ./configure (fixes No. 1535
  at bugs.altlinux.ru).

* Tue Nov  5 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt7
- lisp: leave gnus/format-spec.el* in the main pkg (do not put in gnus):
  kind of essential library (required by tramp);
- scripts:
  + do not install {dir,info}.info; do install idlwave.info;
  + do not install speedbar.info (belongs to the speedbar package);
    WARNING: unless you reinstall emacs-speedbar, its info entry won't
    appear in the catalog;
- gnus subpkg:
  + Provides: gnus = %%name:%%version-%%release; Conflicts: gnus !=...; 
    I suppose other Gnus pkgs should do the same;
  + move {emacs-mime,message}.info to this subpkg.

* Sun Nov  3 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt6
- install more info;
- separate gnus{,-el} (alternatives would be complex in this case due to
  info and etc/, so other gnus should merely conflict with these ones).

* Fri Jul 19 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt5
- follow the convention about using POSIX locks (with fcntl(2)) for 
  mailbox access (in movemail; nnmbox users take care on your own!);
- drop privileges of movemail utility (no dot-locking in /var/mail/); 
- link with tinfo, not ncurses (everything is there in the latest release);
- remove termcap from build deps;
- lisp: drop speedbar.el{,c}, speedbar.info -- you will find it 
        in a separate pkg (Alex Ott <ottalex@narod.ru>);
- etc: add TUTORIAL.ru (Alex Ott);
- rcs-checkin: hide the dependencies on rcs (mhz).

* Sun Apr 14 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt4
- lisp: 
  + add support for X Compound Text with Extended Segments
    in koi8-u and microsoft-cp1251 (koi8-r support already present
    in the offcial GNU release; this is the complete fix for \#786
    at bugs.altlinux.ru);
  + add cp1251 item to the list of choices for ispell coding;
- package:
  + correct preun-scripts (alternative management) (Sorry, you will 
    have to uninstall 21.2-alt3 manually with --noscripts);

* Fri Apr 12 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt3
- rename: /usr/bin/emacs-21.2 to /usr/bin/emacs-X11
  (to overcome the alternatives nightmare);

* Fri Apr 12 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt2
- package: 
  + add Confilcts on older etcskel & app-defaults (the
    old ones use values considered bad for 21.2);
  + Groups of *-el subpkgs changed to Development/Other;
- lisp: add support for X fonts in koi8 and *1251;


* Mon Apr  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt1
- new mainstream release (21.2):
  + now supports ICCCM Extended Segments in X selctions (fixes \#786 at
    bugs.altlinux.ru) -- don't forget to sync etcskel's to use c-text 
    for selections;
- lisp: 
  + prefer clipboard over primary selection (the reasononig given in
    \#795 at bugs.altlinux.ru);
  + the default value for selection-coding-system: 
    compound-text -> compound-text-with-extensions (this is the second part of
    the fix for \#786 at bugs.altlinux.ru)
  + Encoded-kb mode indicator turned off in mainstream release, so 
    we are not applying our previous patch any more;
-config:
  + use "Emacs" class as a specifier for X resourcers (was: "emacs" name)
    (fixes \#764 at bugs.altlinux.ru) -- don't forget to sync /etc/Xresources;
- spec-file:
  + dumbterm-for-compile patch regenerated;
  + alternatives: 
    * weights for alternatives shifted by %{alternativeMajor}00;
    * removal in %%preun to avoid collisions;

* Thu Mar  1 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt13
- fix broken deps between emacsen-startscripts and and emacs-{X11,nox}:
  the pkgs with Emacs executables now provide `emacsen'.

* Thu Feb 28 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt12
- make co-existence with other Emacsen (XEmacs) easier:
  + move the site start scripts to a separate pkg (emacsen-startscripts; 
    they should be shared between GNU and X- Emacsen); buildreq rules for
    the directory with the scripts also moved to that pkg;
  + emacs-{nox,X11} provide emacsen (should be also provided 
    by XEmacs binaries);
  + emacs-{nox,X11} require emacsen-startscripts (should be also required 
    by XEmacs binaries);

* Sat Feb 25 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt11
- get rid of the inconsistency in versions and documentation data between 
  emacs-X11 and emacs-nox variants (fixes \#601, \#612 in bugs.altlinux.ru)
  (%%build stage modified to achieve this);
- add more strict %%release dependencies;
- add support for loading bzipped2 .el/.elc; compress several large files;
- lisp:
    + encoded-kbd: make indicator string shorter;
    + cyrillic-codepages-setup: override `valid-codes' property with more 
      correct values (this fixes hanging on C-x; Note: if you do 
      codepage-setup manually, then it is not fixed for you);
- config:
    + macros: rename noXlaunch -> TTYlaunch;
    + mouse: attempt to use mouse in Linux console and Xterm;
    + initial-features: turn on column-number and eldoc (for el only) modes;
- spec-file:
  + %%install: handle menu simpler;
  + make a patch instead of the separate HELLO.re (append it to Patch20);
  + %%install: generate filelists using el-pkgutils (it should be used also
    in other pkgs with Emacs Lisp code);

* Sun Feb  9 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt10
- lisp: 
  + new version of php-mode (1.0.2); compile it;
    on site-start, initialize autoload of it (php-mode);
  + add more seamless support for Cyrillic language environments based
    on CP1251, CP866 and CP1125;
  + fix CP866 table;
- config:
  + special bindings for selection management discarded -- the defaults 
    work fine (even for X); support for analogous KeyPad bindings added 
    (suggested by vyt@vzljot.ru);
  + X resources: set our values for colour classes; use "Helv" font 
    family for the menu;
  + do not fail completely if the Flyspell feature fails;
  + mouse wheel support turned on;
  + defined GNU-/XEmacs and Xlaunch macros (to be used in personal configs, etcskels);
  + split the config into small parts;
- menu: explicitly specify the X11-variant of emacs;
- spec-file:
  + Head: thrown away unused and recompiled sources; 
    not used terminfo patch left for a while: do we need it??;
  + build: do not copy any byte-compiled .elc files into the build 
    tree -- all of them now get recompiled from the patched sources 
    (particularly quail/cyrillic.elc from leim);
  + install: move menu entry to a separate file;
  + scriplets: use %%*_menus macros;
  + install: cut down "$RPM_BUILD_ROOT" usage;
  + detect errors during Emacs Lisp compilation;

* Thu Jan 24 2002 Dmitry V. Levin <ldv@alt-linux.org> 21.1-alt9
- Added emacs filter for buildreq.

* Thu Dec 27 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt8
- configuration:
  + really turn on pc-selection-mode;
  + move frame properties from site-start.el to X resources;
- lisp: really apply our patches by recompiling the patched sources;
- .el/.elc fractions improved:
  + do not loose any not-compiled .el-files in the emacs-common pkg;
  + split emacs-el into emacs-el and emacs-leim-el subpkgs;
- "TERM in Compile" patch extended (idea by rms@gnu.org);

* Wed Dec 26 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt7
- inherit ispell-dictionary value from the DICTIONARY environment variable
- fix the "TERM in Compile" patch -- now it works

* Wed Dec 26 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt6
- configuration from MdkRE's etcskel-* merged into the global Emacs' config
- set TERM=dumb for compile (for nice output of colorgcc and other programs)
- set ownership on various directories for clean pkg removal
- FAQ excluded from the documentation

* Tue Nov 20 2001 AEN <aen@logic.ru> 21.1-alt5
- update-alternatives fixed (bug 168,169)
- new php-mode.el (bug 170)

* Thu Nov 15 2001 AEN <aen@logic.ru> 21.1-alt4
- fix typo in previous changelog record
- some MDK improvements added

* Tue Nov 13 2001 AEN <aen@logic.ru> 21.1-alt3
- ukrainiazation from Serhii Hlodin

* Thu Nov 1 2001 AEN <aen@logic.ru> 21.1-alt2
- leim cyrillic patches restored

* Mon Oct 22 2001 AEN <aen@logic.ru> 21.1-alt1
- new version

* Fri May 18 2001 Stanislav Ievlev <inger@altlinux.ru> 20.7-ipl9mdk
- Repackaged.
- Moved common %name stuff to %name-common subpackage.
- Used update-alternatives for %name-nox and %name-X11 subpackages.
- Fixed terminfo linkage.

* Sat Feb 17 2001 AEN <aen@logic.ru>
- groups names fixed

* Sat Jan 20 2001 AEN <aen@logic.ru>
- belarusian script in HELLO fixed (Alexander Bokovoy)

* Tue Dec 26 2000 AEN <aen@logic.ru>
- spec cleanup

* Thu Dec 07 2000 AEN <aen@logic.ru>
- 20.7
- rebuild for 7.2RE

* Sat Mar 11 2000 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- load belarusian code at startup

* Thu Jan 13 2000 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- added belarusian language support

* Tue Nov 9 1999 AEN <aen@logic.ru>
- bzipped man-pages
- custom.gz removed
- build for 6.1RE

* Fri Sep 17 1999 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- move to 20.4
- add Ukrainian patches

* Wed May 26 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- move the %_bindir/%name script to the %name package

* Wed May 26 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- s/arch-redhat-linux/arch-mandrake-linux
- replace %name with a shell script that runs either %name-nox or
  %name-20.3
- s/%name/%name-20.3/ in %name.wmconfig (wmconfig is always X)

* Fri Apr 23 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Mandrake adpatations.
- Bzip2 info/man pages.
- Path to handle bzip2 on info files.

* Wed Mar 31 1999 Preston Brown <pbrown@redhat.com>
- updated mh-utils %name lisp file to match our nmh path locations

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 9)

* Fri Feb 26 1999 Cristian Gafton <gafton@redhat.com>
- linker scripts hack to make it build on the alpha

* Fri Jan  1 1999 Jeff Johnson <jbj@redhat.com>
- add leim package (thanks to Pavel.Janik@inet.cz).

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- build against glibc 2.1

* Wed Sep 30 1998 Cristian Gafton <gafton@redhat.com>
- backed up changes to uncompress.el (it seems that the one from 20.2 works
  much better)

* Mon Sep 28 1998 Jeff Johnson <jbj@redhat.com>
- eliminate /tmp race in rcs2log

* Wed Sep 09 1998 Cristian Gafton <gafton@redhat.com>
- upgrade to 20.3

* Tue Jun  9 1998 Jeff Johnson <jbj@redhat.com>
- add --with-pop to X11 compile.
- include contents of %_datadir/.../etc with main package.

* Mon Jun 01 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr

* Mon Jun 01 1998 David S. Miller <davem@dm.cobaltmicro.com>
- fix signals when linked with glibc on non-Intel architectures
  NOTE: This patch is not needed with %name >20.2

* Thu May 07 1998 Prospector System <bugs@redhat.com>

- translations modified for de, fr, tr

* Thu May 07 1998 Cristian Gafton <gafton@redhat.com>
- added %_libdir/%name/20.2/*-mandrake-linux directory in the filelist

* Thu Apr 09 1998 Cristian Gafton <gafton@redhat.com>
- alpha started to like %name-nox again :-)

* Thu Nov  6 1997 Michael Fulbright <msf@redhat.com>
- alpha just doesnt like %name-nox, taking it out for now

* Mon Nov  3 1997 Michael Fulbright <msf@redhat.com>
- added multibyte support back into %name 20.2
- added wmconfig for X11 %name
- fixed some errant buildroot references

* Thu Oct 23 1997 Michael Fulbright <msf@redhat.com>
- joy a new version of %name! Of note - no lockdir any more.
- use post/preun sections to handle numerous GNU info files

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>
- stopped stripping it as it seems to break things

* Sun Sep 14 1997 Erik Troan <ewt@redhat.com>
- turned off ecoff support on the Alpha (which doesn't build anymore)

* Mon Jun 16 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Fri Feb 07 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved ctags to gctags to fit in the more powerful for C (but less
  general) exuberant ctags as the binary %_bindir/ctags and the
  man page /usr/man/man1/ctags.1
# Local Variables:
# compile-command: "rpmbuild -ba --target=i586 emacs.spec"
# End:
